# Harvest Support and Getting Help

Welcome to Harvest! Harvest is an official NetApp open-source project. You can reach out
to NetApp using any of the [standard mechanisms](http://mysupport.netapp.com/info/web/ECMLP2619434.html) and get support.

This document describes Harvest's release and support lifecycle as well as places you can get help.

## Harvest's Release and Support Lifecycle

Harvest's current release schedule is quarterly in January, April, July, and October, but it may change at our discretion. 

Each release of Harvest supports the most recently released version of ONTAP. We try our best to also support earlier versions of ONTAP. When that's not possible, breaking changes will be outlined in the changelog.

Harvest is constantly being improved with new features and bug fixes. Customers are encouraged to upgrade frequently to take advantage of these improvements.

`We intend to support each Harvest release for 12 months.`

For example, when `YY.MM` (ex: 21.04) is released, we intend to support it until `YY+1.MM` (ex: 22.04) is released. At the same time, `YY-1.MM` (ex: 20.04) and associated minor releases (ex: 20.04.1) move to limited or no support.

If you are running a version of Harvest that’s more than 12 months old, you must upgrade to a newer version to receive any support then available from NetApp. We always recommend running the latest version.

We use GitHub for tracking bugs and feature requests.

# Getting Help

There is also a vibrant community of Harvest users on NetApp's community discussion board and the `#harvest` channel in [NetApp's Slack team](https://ulleundgeorg.slack.com). This is a great place to ask general questions about the project and discuss related topics with like-minded peers.

## NetApp Community Discussion Board

The Harvest Community is active on the NetApp Community Discussion Board, you can post your questions there:

* [NetApp Community Discussion Board](https://community.netapp.com/t5/Data-Infrastructure-Management-Software-Discussions/bd-p/oncommand-storage-management-software-discussions)

  * Here are some tips on [how to ask good questions](https://stackoverflow.com/help/how-to-ask).

## Documentation

* [Harvest Documentation](https://github.com/NetApp/Harvest/docs)

## Real-time Chat

* [Slack](https://ulleundgeorg.slack.com) ([registration](https://join.slack.com/t/netapppub/shared_invite/zt-njcjx2sh-1VR2mEDvPcJAmPutOnP~mg)):
The `#harvest` channel is the best place to chat with like-minded Harvesters.
